CPP=g++ --std=c++11 -Wall

ALL = clean Prog run
all:$(ALL)

Prog : Main.o Gate.o ANDGate.o NANDGate.o NORGate.o NOTGate.o NXORGate.o ORGate.o XORGate.o InputGate.o OutputGate.o Arbre.o ParserFic.o Gate1Input.o Gate2Input.o GateNoInput.o Node.o ArbreView.o Shell.o ParserCommandLine.o
	$(CPP) -o Prog Main.o Gate.o ANDGate.o NANDGate.o NORGate.o NOTGate.o NXORGate.o ORGate.o XORGate.o InputGate.o OutputGate.o Arbre.o ParserFic.o Gate1Input.o Gate2Input.o GateNoInput.o Node.o ArbreView.o Shell.o ParserCommandLine.o

Main.o : Main.cpp Gate.hpp ANDGate.hpp NANDGate.hpp NORGate.hpp NOTGate.hpp NXORGate.hpp ORGate.hpp XORGate.hpp InputGate.hpp OutputGate.hpp Arbre.hpp Gate1Input.hpp Gate2Input.hpp GateNoInput.hpp Node.hpp ArbreView.hpp Shell.hpp ParserCommandLine.hpp
	$(CPP) -c Main.cpp

ParserCommandLine.o : ParserCommandLine.cpp ParserCommandLine.hpp
	$(CPP) -c ParserCommandLine.cpp

Shell.o : Shell.cpp Shell.hpp ArbreView.hpp
	$(CPP) -c Shell.cpp

Gate.o : Gate.cpp Gate.hpp
	$(CPP) -c Gate.cpp

ANDGate.o : ANDGate.cpp  ANDGate.hpp Gate2Input.hpp
	$(CPP) -c ANDGate.cpp

NANDGate.o : NANDGate.cpp NANDGate.hpp Gate2Input.hpp
	$(CPP) -c NANDGate.cpp

NORGate.o : NORGate.cpp NORGate.hpp Gate2Input.hpp
	$(CPP) -c NORGate.cpp

NOTGate.o : NOTGate.cpp NOTGate.hpp Gate1Input.hpp
	$(CPP) -c NOTGate.cpp

NXORGate.o : NXORGate.cpp NXORGate.hpp Gate2Input.hpp
	$(CPP) -c NXORGate.cpp

ORGate.o : ORGate.cpp ORGate.hpp Gate2Input.hpp
	$(CPP) -c ORGate.cpp

XORGate.o : XORGate.cpp XORGate.hpp Gate2Input.hpp
	$(CPP) -c XORGate.cpp

InputGate.o : InputGate.cpp InputGate.hpp GateNoInput.hpp
	$(CPP) -c InputGate.cpp

OutputGate.o : OutputGate.cpp OutputGate.hpp Gate1Input.hpp
	$(CPP) -c OutputGate.cpp

Arbre.o : Arbre.cpp Arbre.hpp Node.hpp
	$(CPP) -c Arbre.cpp

ParserFic.o : ParserFic.cpp ParserFic.hpp Arbre.hpp Gate.hpp
	$(CPP) -c ParserFic.cpp

Gate1Input.o : Gate1Input.cpp Gate1Input.hpp Gate.hpp
	$(CPP) -c Gate1Input.cpp

Gate2Input.o : Gate2Input.cpp Gate2Input.hpp Gate.hpp
	$(CPP) -c Gate2Input.cpp

GateNoInput.o : GateNoInput.cpp GateNoInput.hpp
	$(CPP) -c GateNoInput.cpp

Node.o : Node.cpp Node.hpp Gate.hpp
	$(CPP) -c Node.cpp

ArbreView.o : ArbreView.cpp ArbreView.hpp Arbre.hpp Gate.hpp
	$(CPP) -c ArbreView.cpp

run :
	./Prog

clean :
	rm -rf $(ALL) *.o